﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace SDF.Pagination
{
    public class HarvestResult
    {
        #region Constructor

        public HarvestResult(SmartBlock block, double remainingHeight)
            : this(block, remainingHeight, false, false)
        { 
        }

        public HarvestResult(SmartBlock block, double remainingHeight, bool addColumnBreak, bool addPageBreak)
        {
            if (remainingHeight < 0)
                remainingHeight = 0;
                
            HarvestedBlock = block;
            RemainingHeight = remainingHeight;

            if (remainingHeight == 0)
                AddColumnBreak = true;
            else
                AddColumnBreak = addColumnBreak;
    
            AddPageBreak = addPageBreak;
        }

        #endregion

        #region Properties

        public double RemainingHeight { get; private set; }

        public SmartBlock HarvestedBlock { get; private set; }

        public bool AddColumnBreak { get; private set; }

        public bool AddPageBreak { get; private set; }

        #endregion

        #region Static Properties

        public static readonly HarvestResult BreakColumn = new HarvestResult(null, 0, true, false);

        public static readonly HarvestResult BreakPage = new HarvestResult(null, 0, true, true);

        #endregion
    }
}
