﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media.TextFormatting;
using System.Windows.Documents;
using System.Windows;

namespace SDF.TextFormatting
{
    public class SmartTextParagraphProperties: TextParagraphProperties
    {
        #region Constructor

        public SmartTextParagraphProperties(SmartTextElement element)
        {
            if (element == null)
                throw new ArgumentNullException("element");

            _DefaultTextRunProperties = new SmartTextRunProperties(element);
            _FlowDirection = element.FlowDirection;
            _LineHeight = element.LineHeight;
            _TextAlignment = element.TextAlignment;
            _FirstLineInParagraph = false;
        }


        #endregion

        #region Overriden Properties 

        public override TextRunProperties DefaultTextRunProperties
        {
            get { return _DefaultTextRunProperties; }
        }
        private TextRunProperties _DefaultTextRunProperties;

        public override bool FirstLineInParagraph 
        {
            get { return _FirstLineInParagraph; }
        }
        private bool _FirstLineInParagraph;

        public override FlowDirection FlowDirection
        {
            get { return _FlowDirection; }
        }
        private FlowDirection _FlowDirection;

        public override double Indent
        {
            get { return 0; }
        }

        public override double LineHeight 
        { 
            get { return _LineHeight; }  
        }
        private double _LineHeight;

        public override TextAlignment TextAlignment 
        { 
            get { return _TextAlignment; }
        }
        private TextAlignment _TextAlignment;

        public override TextMarkerProperties TextMarkerProperties
        {
            get { return null; }
        }

        public override TextWrapping TextWrapping
        {
            get { return TextWrapping.Wrap; }
        }

        #endregion

        #region SetTextAlignment

        public void SetTextAlignment(TextAlignment value)
        {
            _TextAlignment = value;
        }

        #endregion
    }
}
